Attribute VB_Name = "mBrowseForFolder"
Option Explicit

Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000

Private Type BROWSEINFO
  hOwner As Long
  pidlRoot As Long
  pszDisplayName As String
  lpszTitle As String
  ulFlags As Long
  lpfn As Long
  lParam As Long
  iImage As Long
End Type
Public Function GetFolder(ByVal hWnd As Long, ByVal sTitle As String) As String
'Set the properties of the folder dialog
Dim bInf As BROWSEINFO
bInf.hOwner = hWnd
bInf.lpszTitle = sTitle
bInf.ulFlags = BIF_RETURNONLYFSDIRS

'Show the Browse For Folder dialog
Dim lPathID As Long
lPathID = SHBrowseForFolder(bInf)

Dim lRetVal As Long
Dim sPath As String
sPath = Space$(512)
lRetVal = SHGetPathFromIDList(ByVal lPathID, ByVal sPath)

If lRetVal Then
    'remove null chars
    Dim iOffset As Integer
    iOffset = InStr(sPath, Chr$(0))
    
    If iOffset <> 0 Then
        GetFolder = Left$(sPath, iOffset - 1)
    Else
        GetFolder = sPath
    End If
End If
End Function


